
image: python:3.6

stages:
  - tests
  - publish
  
#tox will test py27 and py36 by himself
tests:
  stage: tests
  script:
  - pip install tox==3.0.0
  - tox

.python_publish: &python_publish
  script:
  # trigger ltu-engine-python-project to publish project in devpi
  # 9113874 ltu-engine-python-project ID
  - curl -X POST -F token=$PACKAGING_TOKEN -F variables[MODE_BUILD]=$MODE -F ref=master https://gitlab.com/api/v4/projects/9113874/trigger/pipeline

# Filter: Run on master and all release branches!
.master_branches: &master_branches
  only:
    - master
    # Run on master and 7-5-X-branch
    - /^\d+\.\d+\.X_branch/
    - /^\d+\-\d+\-X_branch/

# Filter: Run on tags!
.tags: &tags
  only:
    - tags

# Filter: Run only on developper merge requests
.dev_branches: &dev_branches
  except:
    - master
    # Run on master and 7-5-X-branch
    - /^\d+\.\d+\.X_branch/
    - /^\d+\-\d+\-X_branch/
    - tags

# run for all builds except tags because we are pushing to the /ltu/trash index
python_publish_trash:
  stage: publish
  <<: *python_publish
  <<: *dev_branches
  variables:
    MODE: trash

# run for all builds except tags because we are pushing to the /ltu/dev index
python_publish_dev:
  stage: publish
  <<: *python_publish
  <<: *master_branches
  variables:
    MODE: dev

# run for all released tags because we are pushing to the /ltu/prod index
python_publish_prod:
  stage: publish
  <<: *python_publish
  <<: *tags
  variables:
    MODE: prod